%Egidio Rezzaghi ITIS "G. Galilei" Mirandola
%caratmo.m
%
% Elaborazione delle caratteristiche di funzionamento di un mtore asincrono
% trifase, dedotte indirettamente mediante le prove a vuoto, in corto e la
% misura della resistenza statorica.

echo off
close
clc
clear

disp(' ')
disp('             CARATTERISTICHE DEL MAT  (E. Rezzaghi)')
disp('             --------------------------------------')
disp(' ')
disp('Nota Bene: Le serie di valori numerici, come nel caso dei vettori, vanno')
disp('           introdotte racchiudendole tra parentesi quadre e separando i')
disp('           singoli valori con uno spazio bianco od una virgola.')
disp('           Il separatore tra la parte intera e quella decimale  il punto.')
disp(' ')
disp('Tutti i dati si intendono alla temperatura convenzionale di riferimento.')
disp(' ')

xxx=' (E. Rezzaghi)';

%introduzione dei dati di targa:
disp('DATI DI TARGA DELLA MACCHINA :')
pn=input('Potenza erogata nominale [W] = ');
fn=input('Frequenza nominale [Hz] = ');
vn=input('Tensione nominale [V] = ');

in=pn/(0.8*vn);
while in>=pn/(0.8*vn)
  in=input('Corrente nominale [A] = ');
  if in>=pn/(0.8*vn)
    disp(['Deve essere In < ',num2str(pn/(0.8*vn)),' [A] !'])
  end
end

nc=input('Numero coppie polari = ');

iavv=in;
while iavv<=in
  iavv=input('Corrente di avviamento [A] = ');
  if iavv<=in
    disp(['Deve essere Iavv > ',num2str(in),' [A] !'])
  end
end

cosfcc=1;
while cosfcc>=1
  cosfcc=input('Fattore di potenza in cortocircuito = ');
  if cosfcc>=1
    disp('Deve essere cosfcc < 1 !')
  end
end 

io=in;
while io>=in
  io=input('Corrente assorbita a vuoto [A] = ');
  if io>=in
    disp(['Deve essere Io < ',num2str(io),' [A] !'])
  end
end

cosfo=cosfcc;
while cosfo>=cosfcc
  cosfo=input('Fattore di potenza a vuoto = ');
  if cosfo>=cosfcc
    disp(['Deve essere cosfo < ',num2str(cosfcc),' !'])
  end
end

r1s=cosfcc*vn/(1.732*iavv);
while r1s>=cosfcc*vn/(1.732*iavv)
  r1s=input('Resistenza di una fase di statore a stella [Ohm] = ');
  if r1s>=cosfcc*vn/(1.732*iavv)
    disp(['Deve essere la resistenza < ',num2str(cosfcc*vn/(1.732*iavv)),' [Ohm] !'])
  end
end 

disp(' ')

%pn=3000;fn=50;vn=380;in=6.8;nc=2;iavv=29.39;cosfcc=0.585;io=3.24;cosfo=0.109;r1s=1.922;

%Calcolo le perdite costanti ed i parametri trasversali a statore:
pcost=1.732*io*vn*cosfo;
ro=vn^2/pcost;
xo=ro/tan(acos(cosfo));

%Calcolo le perdite nel rame, le perdite addizionali, il rendimento convenzionale
%a pieno carico, i parametri longitudinali a statore:
zes=vn/(1.732*iavv);res=zes*cosfcc;xes=res*tan(acos(cosfcc));
pcc=3*res*in^2;pad=5*(pn+pcost+pcc)/995;rec=pn/(pn+pcost+pcc+pad);

%Comunicazione in una finestra dei dati:
figure
x0=.10;y0=.97;dx=.10;dy=.05;
figtext(x0+.1,y0,'DATI DI TARGA (E. Rezzaghi)')
msgtxt=['Potenza nominale = ',num2str(pn),' [W]'];
figtext(x0,y0-dy,msgtxt)
msgtxt=['Frequenza nominale = ',num2str(fn),' [Hz]'];
figtext(x0,y0-2*dy,msgtxt)
msgtxt=['Tensione nominale = ',num2str(vn),' [V]'];
figtext(x0,y0-3*dy,msgtxt)
msgtxt=['Corrente nominale = ',num2str(in),' [A]'];
figtext(x0,y0-4*dy,msgtxt)
msgtxt=['Numero coppie polari = ',num2str(nc)];
figtext(x0,y0-5*dy,msgtxt)
msgtxt=['Corrente d''avviamento = ',num2str(iavv),' [A]'];
figtext(x0,y0-6*dy,msgtxt)
msgtxt=['Fattore di potenza in corto = ',num2str(cosfcc)];
figtext(x0,y0-7*dy,msgtxt)
msgtxt=['Corrente a vuoto = ',num2str(io),' [A]'];
figtext(x0,y0-8*dy,msgtxt)
msgtxt=['Fattore di potenza a vuoto = ',num2str(cosfo)];
figtext(x0,y0-9*dy,msgtxt)
msgtxt=['Resistenza di una fase statorica a Y = ',num2str(r1s),' [Ohm]'];
figtext(x0,y0-10*dy,msgtxt)
msgtxt=['Perdite costanti = ',num2str(pcost),' [W]'];
figtext(x0,y0-12*dy,msgtxt)
msgtxt=['Resistenza equiv. trasv. allo statore = ',num2str(ro),' [Ohm]'];
figtext(x0,y0-13*dy,msgtxt)
msgtxt=['Reattanza equiv. trasv. allo statore = ',num2str(xo),' [Ohm]'];
figtext(x0,y0-14*dy,msgtxt)
msgtxt=['Perdite nel rame = ',num2str(pcc),' [W]'];
figtext(x0,y0-15*dy,msgtxt)
msgtxt=['Resistenza equiv. longit. allo statore = ',num2str(res),' [Ohm]'];
figtext(x0,y0-16*dy,msgtxt)
msgtxt=['Reattanza equiv. longit. allo statore = ',num2str(xes),' [Ohm]'];
figtext(x0,y0-17*dy,msgtxt)
msgtxt=['Rendimento convenzionale a p. c. = ',num2str(rec)];
figtext(x0,y0-18*dy,msgtxt)
msgtxt=['Coppia convenzionale CEI = ',num2str(0.15915*pn*nc/fn)];
figtext(x0,y0-19*dy,msgtxt)
input('Premi il tasto Return ...','s');

%Calcolo e disegno del diagramma circolare:
scp=1.732*vn;scc=scp*nc/(6.283*fn); %scale per la lettura
cpo=[io*sin(acos(cosfo)),io*cosfo]; %coordinate Io
cpcc=[iavv*sin(acos(cosfcc)),iavv*cosfcc]; %coordinate Iavv
cavvr=sqrt((cpcc(1)-cpo(1))^2+(cpcc(2)-cpo(2))^2); %corrente di reazion. avv.
raggio=0.5*cavvr^2/(cpcc(1)-cpo(1)); %raggio DC
centro=[cpo(1)+raggio,cpo(2)]; %coordinate centro DC
%Coordinate In:
a1=(in^2+centro(1)^2+centro(2)^2-raggio^2)/(2*centro(2));
a2=2*a1*centro(1)/centro(2);
a3=(centro(1)^2+centro(2)^2)/centro(2)^2;
inx=(a2-sqrt(a2^2-4*a3*(a1^2-in^2)))/(2*a3);
iny=sqrt(in^2-inx^2);
angrp=asin((cpcc(2)-cpo(2))/cavvr);%angolo pendenza retta potenze rese
angrc=atan(r1s*sin(angrp)/(res*cos(angrp)));%angolo pendenza retta coppie
ang=linspace(0,pi,100);
figure
plot([0,cpo(1)],[0,cpo(2)],'y',[0,cpcc(1)],[0,cpcc(2)],'y',...
     [0,inx],[0,iny],'y',...
     [cpo(1),cpo(1)+2*raggio],[cpo(2),cpo(2)],'c',...
     [cpo(1)+raggio,cpo(1)+raggio],[0.5*cpo(2),1.5*cpo(2)],'c',...
     centro(1)-raggio.*cos(ang),cpo(2)+raggio.*sin(ang),'c',...
     [cpo(1),1.1*cpcc(1)],[cpo(2),cpo(2)+(1.1*cpcc(1)-cpo(1))*tan(angrp)],'r',...
     [cpo(1),cpo(1)+2*raggio],[cpo(2),cpo(2)+2*raggio*tan(angrc)],'r'),...
     axis('equal'),grid,...
     title(['Diagramma circolare: V = ',num2str(vn),' [V], f = ',...
            num2str(fn),' [Hz], pp = cost.',xxx]),...
     xlabel(['Scale : 1 = 1 [A], 1 = ',num2str(scp),' [W], 1 = ',...
             num2str(scc),' [N*m]']),...
     text(cpo(1),-2*cpo(2),'Io'),text(inx,iny,'  In'),text(cpcc(1),cpcc(2),'   Iavv')
input('Premi il tasto Return ...','s');

%Determinazione delle caratteristiche tra s=0 ed s=1:
alfa=acos((-cavvr^2+2*raggio^2)/(2*raggio^2));
ang=linspace(0,alfa,100);
%coord. cor.
ix=-raggio*cos(ang)+centro(1);
iy=raggio*sin(ang)+cpo(2);
ia=sqrt(ix.^2+iy.^2); %modulo corrente assorbita
cosfia=iy./ia;
pass=iy*scp;
presa=(iy-cpo(2)-(ix-cpo(1))*tan(angrp))*scp;presa(1)=0;
ptras=(iy-cpo(2)-(ix-cpo(1))*tan(angrc))*scp;ptras(1)=1;
coppia=(iy-cpo(2)-(ix-cpo(1))*tan(angrc))*scc;coppia(1)=0;
rend=presa./pass;
scor=(ptras-presa)./ptras;scor(1)=0;ptras(1)=0;

%Determinazione delle caratteristiche per In , coppia max., coppia avv.:
cosfian=iny/in;
passn=iny*scp;
presan=(iny-cpo(2)-(inx-cpo(1))*tan(angrp))*scp;
ptrasn=(iny-cpo(2)-(inx-cpo(1))*tan(angrc))*scp;
coppian=(iny-cpo(2)-(inx-cpo(1))*tan(angrc))*scc;
rendn=presan/passn;
scorn=(ptrasn-presan)/ptrasn;
[cmax,iscmax]=max(coppia); %massima coppia e suo indice nel vettore coppia
scmax=scor(iscmax);
cavv=coppia(length(coppia)); %coppia avviamento

%Disegno caratteristica meccanica:
figure
plot(scor,coppia,'y',[scorn,scorn],[0,coppian],'y',...
     [0,scorn],[coppian,coppian],'y',...
     [scmax,scmax],[0,cmax],'y',[0,scmax],[cmax,cmax],'y'),...
     axis('auto'),grid,...
     title(['Caratteristica meccanica: V = ',num2str(vn),' [V], f = ',...
            num2str(fn),' [Hz], pp = cost.',xxx]),...
     xlabel('scorrimento');ylabel('coppia [N*m]'),...
     text(scorn,max(coppia)/25,[' ',num2str(scorn)]),...
     text(scorn,coppian,[' ',num2str(coppian)]),...
     text(1,cavv,[' ',num2str(cavv)]),text(scmax,max(coppia)/25,[' ',num2str(scmax)]),...
     text(0,1.03*cmax,[' ',num2str(cmax)]),...
     text(1,cavv,[' ',num2str(cavv)])
input('Premi il tasto Return ...','s');

%Disegno caratteristiche scorr, rend, cosf:
figure
plot(ia,cosfia,'y',ia,rend,'c',ia,scor,'g'),grid,...
    title(['scorr., rend., fdp : V = ',num2str(vn),' [V], f = ',...
           num2str(fn),' [Hz], pp = cost.',xxx]),...
    xlabel('Corrente assorbita [A]');ylabel('scor , rend. , fdp'),...
    text(ia(round(0.5*length(ia))),cosfia(round(0.5*length(cosfia))),'  cosf'),...
    text(ia(round(0.5*length(ia))),rend(round(0.5*length(rend))),'  rend'),...
    text(ia(round(0.5*length(ia))),scor(round(0.5*length(scor))),'  scor')
input('Premi il tasto Return ...','s');

%Disegno caratteristiche potenza assorbita, potenza trasmessa, resa:
figure
plot(ia,pass,'y',ia,ptras,'c',ia,presa,'g'),grid,...
    title(['Potenze : V = ',num2str(vn),' [V], f = ',...
           num2str(fn),' [Hz], pp = cost.',xxx]),...
    xlabel('Corrente assorbita [A]');ylabel('potenza [W]'),...
    text(ia(round(0.8*length(ia))),pass(round(0.8*length(pass))),'  Pass'),...
    text(ia(round(0.8*length(ia))),ptras(round(0.8*length(ptras))),'  Ptras'),...
    text(ia(round(0.8*length(ia))),presa(round(0.8*length(presa))),'  Presa')
input('Premi il tasto Return ...','s');

%Comunicazione risultati riassuntivi:
figure
x0=.10;y0=.97;dx=.10;dy=.05;
figtext(x0+.1,y0,'RIEPILOGO DEI RISULTATI (E. Rezzaghi)')
msgtxt='Comportamento all''avviamento a piena tensione :';
figtext(x0,y0-2*dy,msgtxt)
msgtxt=['corrente assorbita = ',num2str(iavv),' [A]'];
figtext(x0,y0-3*dy,msgtxt)
msgtxt=['fattore di potenza = ',num2str(cosfcc),' r'];
figtext(x0,y0-4*dy,msgtxt)
msgtxt=['coppia di spunto = ',num2str(cavv),' [N*m]'];
figtext(x0,y0-5*dy,msgtxt)
msgtxt='Comportamento con corrente assorbita nominale :';
figtext(x0,y0-7*dy,msgtxt)
msgtxt=['fattore di potenza = ',num2str(cosfian),' r'];
figtext(x0,y0-8*dy,msgtxt)
msgtxt=['potenza assorbita = ',num2str(passn),' [W]'];
figtext(x0,y0-9*dy,msgtxt)
msgtxt=['potenza erogata = ',num2str(presan),' [W]'];
figtext(x0,y0-10*dy,msgtxt)
msgtxt=['coppia resa = ',num2str(coppian),' [N*m]'];
figtext(x0,y0-11*dy,msgtxt)
msgtxt=['rendimento = ',num2str(rendn)];
figtext(x0,y0-12*dy,msgtxt)
msgtxt=['scorrimento = ',num2str(scorn)];
figtext(x0,y0-13*dy,msgtxt)
msgtxt=['velocit = ',num2str(60*fn*(1-scorn)/nc),' [g/'']'];
figtext(x0,y0-14*dy,msgtxt)
msgtxt='Coppia massima sviluppabile :';
figtext(x0,y0-16*dy,msgtxt)
msgtxt=['scorrimento di massima coppia = ',num2str(scmax)];
figtext(x0,y0-17*dy,msgtxt)
msgtxt=['coppia massima = ',num2str(cmax),' [N*m]'];
figtext(x0,y0-18*dy,msgtxt)
input('Premi il tasto Return ...','s');