%Egidio Rezzaghi ITIS "G. Galilei" Mirandola
%carattr.m
%
% Elaborazione delle caratteristiche di funzionamento di un trasformatore
% industriale, dedotte indirettamente mediante le prove a vuoto ed in
% cortocircuito.

echo off
close
clc
clear

disp(' ')
disp('             CARATTERISTICHE DEL TR  (E. Rezzaghi)')
disp('             -------------------------------------')
disp(' ')
disp('Nota Bene: Le serie di valori numerici, come nel caso dei vettori, vanno')
disp('           introdotte racchiudendole tra parentesi quadre e separando i')
disp('           singoli valori con uno spazio bianco od una virgola.')
disp('           Il separatore tra la parte intera e quella decimale  il punto.')
disp(' ')
disp('Tutti i dati si intendono alla temperatura convenzionale di riferimento.')
disp(' ')

xxx=' (E. Rezzaghi)';

%scelta del tipo di trasformatore:
tipotr='d';
while (tipotr~='t' & tipotr~='T' & tipotr~='m' & tipotr~='M')
  tipotr=input('Il trasformatore  trifase o monofase (t/m) ? ','s');
end
disp(' ')

%introduzione dei dati di targa:
disp('DATI DI TARGA DELLA MACCHINA :')
an=input('Potenza nominale [VA] = ');
fn=input('Frequenza nominale [Hz] = ');
v1n=input('Tensione nominale primaria [V] = ');
v20n=input('Tensione nominale secondaria [V] = ');
ver=input('Tensione d''uscita normale a carico [V] = ');
ctrv='f';
while ctrv=='f'
  vcc=input('Tensione percentuale di cortocircuito = ');
  pcc=input('Potenza percentuale di cortocircuito = ');
  if pcc<vcc ctrv='v';
    else
    disp('Deve essere Pcc < Vcc !')
  end
end    
ctrv='f';
while ctrv=='f'
  io=input('Corrente percentuale a vuoto = ');
  po=input('Potenza percentuale a vuoto = ');
  if po<io ctrv='v';
    else
    disp('Deve essere Po < Io !')
  end
end 
disp(' ')

%calcolo della corrente nominale al secondario e dei parametri del circuito
%equivalente, loro comunicazione in una finestra:
if (tipotr=='m' | tipotr=='M') i2n=an/v20n;
  else i2n=an/(1.732*v20n);
end
r01=v1n^2/(0.01*po*an);
xm1=r01/tan(acos(po/io));
if (tipotr=='m' | tipotr=='M') req2=0.01*pcc*an/i2n^2;
  else req2=0.01*pcc*an/(3*i2n^2);
end
xeq2=req2*tan(acos(pcc/vcc));
if (tipotr=='m' | tipotr=='M') i2mr=sqrt(0.01*po*an/req2);
  else i2mr=sqrt(0.01*po*an/(3*req2));
end
figure
x0=.10;y0=.97;dx=.10;dy=.05;
figtext(x0+0.1,y0,'DATI DI TARGA (E. Rezzaghi)')
if (tipotr=='m' | tipotr=='M') figtext(x0,y0-dy,'Trasformatore monofase')
  else figtext(x0,y0-dy,'Trasformatore trifase')
end
msgtxt=['Potenza nominale = ',num2str(an),' [VA]'];
figtext(x0,y0-2*dy,msgtxt)
msgtxt=['Frequenza nominale = ',num2str(fn),' [Hz]'];
figtext(x0,y0-3*dy,msgtxt)
msgtxt=['Tensione primaria nom. = ',num2str(v1n),' [V]'];
figtext(x0,y0-4*dy,msgtxt)
msgtxt=['Tensione secondaria nom. = ',num2str(v20n),' [V]'];
figtext(x0,y0-5*dy,msgtxt)
msgtxt=['Tensione secondaria a carico = ',num2str(ver),' [V]'];
figtext(x0,y0-6*dy,msgtxt)
msgtxt=['Perdite in cortocircuito = ',num2str(pcc),' %'];
figtext(x0,y0-7*dy,msgtxt)
msgtxt=['Tensione di cortocircuito = ',num2str(vcc),' %'];
figtext(x0,y0-8*dy,msgtxt)
msgtxt=['Perdite a vuoto = ',num2str(po),' %'];
figtext(x0,y0-9*dy,msgtxt)
msgtxt=['Corrente a vuoto = ',num2str(io),' %'];
figtext(x0,y0-10*dy,msgtxt)
msgtxt=['Corrente nominale sec. = ',num2str(i2n),' [A]'];
figtext(x0,y0-11*dy,msgtxt)
msgtxt=['Resistenza trasv. al primario = ',num2str(r01),' [Ohm]'];
figtext(x0,y0-12*dy,msgtxt)
msgtxt=['Reattanza trasv. al primario = ',num2str(xm1),' [Ohm]'];
figtext(x0,y0-13*dy,msgtxt)
msgtxt=['Resistenza longit. al secondario = ',num2str(req2),' [Ohm]'];
figtext(x0,y0-14*dy,msgtxt)
msgtxt=['Reattanza longit. al secondario = ',num2str(xeq2),' [Ohm]'];
figtext(x0,y0-15*dy,msgtxt)
msgtxt=['Corrente sec. di max. rendim. teorico = ',num2str(i2mr),' [A]'];
figtext(x0,y0-16*dy,msgtxt)
msgtxt=['Rendimento conv. a pieno carico = ',num2str(1/(1+0.01*pcc+0.01*po))];
figtext(x0,y0-17*dy,msgtxt)
input('Premi il tasto Return ...','s');


%Caratteristiche esterne con V1 nominale, fdp 1, 0.8r:
i2=0:i2n/30:i2n*1.25;
if (tipotr=='m' | tipotr=='M')
  v21=v20n-(i2.*req2+i2.^2.*xeq2^2/(2*v20n));
  else v21=1.732*(0.57735*v20n-(i2.*req2+i2.^2.*xeq2^2/(1.1547*v20n)));
end
if (tipotr=='m' | tipotr=='M')
  v208=v20n-(i2.*(req2*0.8+xeq2*0.6)+i2.^2.*(xeq2*0.8-req2*0.6)^2/(2*v20n));
  else v208=1.732*(0.57735*v20n-(i2.*(req2*0.8+xeq2*0.6)+i2.^2.*(xeq2*0.8-req2*0.6)^2/(1.1547*v20n)));
end
figure
axis([0,i2n*1.25,0.85*v20n,v20n*1.1]);
v=axis;
t=['Car. est., ----- cosf=1, - - - cosf=0.8r',xxx];
as='corrente erogata [A]';
o='tensione in uscita [V]';
vx=i2(31);ord=v21(31);ord08=v208(31);
vxs=num2str(vx);ords=num2str(ord);ord08s=num2str(ord08);

plot(i2,v21,'y',[vx,vx],[v(3),ord],'y',[v(1),vx],[ord,ord],'y',...
  i2,v208,'- -c',[v(1),vx],[ord08,ord08],'- -c'),...
  grid,title(t),xlabel(as),ylabel(o),...
  text(v(1)+(v(2)-v(1))/90,v20n+(v(4)-v(3))/40,num2str(v20n))  
  text(v(1)+(v(2)-v(1))/90,ord+(v(4)-v(3))/40,ords)
  text(v(1)+(v(2)-v(1))/90,ord08-(v(4)-v(3))/40,ord08s)
  text(i2n,v(3)*1.005,[' ',num2str(i2n)])
  text(v(2)*0.71,v(4)*0.9,['V1 = ',num2str(v1n),'  [V]'])
  text(v(2)*0.71,v(4)*0.89,['f = ',num2str(fn),' [Hz]'])
input('Premi il tasto Return ...','s');


%Caratteristiche di regolazione:
if (tipotr=='m' | tipotr=='M')
  v11=(v1n/v20n)*sqrt((ver+i2.*req2).^2+(i2.*xeq2).^2);
  else v11=(v1n/v20n)*1.732*sqrt((0.57735*ver+i2.*req2).^2+(i2.*xeq2).^2);
end
if (tipotr=='m' | tipotr=='M')
  v108=(v1n/v20n)*sqrt((ver*0.8+i2.*req2).^2+(ver*0.6+i2.*xeq2).^2);
  else v108=(v1n/v20n)*1.732*sqrt((0.57735*ver*0.8+i2.*req2).^2+(0.57735*ver*0.6+i2.*xeq2).^2);
end
figure
axis([0,i2n*1.25,0.85*v108(38),1.1*v108(38)]);
v=axis;
t=['Curve di reg., ----- cosf=1, - - - cosf=0.8r',xxx];
as='corrente erogata [A]';
o='tensione applicata [V]';
ord=v11(31);ord08=v108(31);
ords=num2str(ord);ord08s=num2str(ord08);

plot(i2,v11,'y',[vx,vx],[v(3),ord08],'y',[v(1),vx],[ord,ord],'y',...
  i2,v108,'- -c',[v(1),vx],[ord08,ord08],'- -c'),...
  grid,title(t),xlabel(as),ylabel(o),...
  text(v(1)+(v(2)-v(1))/90,ver*v1n/v20n-(v(4)-v(3))/40,num2str(ver*v1n/v20n))  
  text(v(1)+(v(2)-v(1))/90,ord-(v(4)-v(3))/40,ords)
  text(v(1)+(v(2)-v(1))/90,ord08+(v(4)-v(3))/40,ord08s)
  text(i2n,v(3)*1.005,[' ',num2str(i2n)])
  text(v(2)*0.1,v(3),['V2 = ',num2str(ver),'  [V]'])
  text(v(2)*0.1,v(3)*1.01,['f = ',num2str(fn),' [Hz]'])
input('Premi il tasto Return ...','s');


%Caratteristiche del rendimento:
if (tipotr=='m' | tipotr=='M')
  rn1=v21.*i2./(v21.*i2+req2*i2.^2+0.01*po*an);
  else rn1=1.732*v208.*i2./(1.732*v208.*i2+3*req2*i2.^2+0.01*po*an);
end
if (tipotr=='m' | tipotr=='M')
  rn08=v21.*i2*0.8./(v21.*i2*0.8+req2*i2.^2+0.01*po*an);
  else rn08=1.38564*v208.*i2./(1.38564*v208.*i2+3*req2*i2.^2+0.01*po*an);  
end
figure
axis([0,i2n*1.25,0,1]);
v=axis;
t=['Rendimento, ----- cosf=1, - - - cosf=0.8r',xxx];
as='corrente erogata [A]';
o='rendimento';
ord=rn1(31);ord08=rn08(31);
ords=num2str(ord);ord08s=num2str(ord08);

plot(i2,rn1,'y',[vx,vx],[v(3),ord],'y',[v(1),vx],[ord,ord],'y',...
  i2,rn08,'- -c',[v(1),vx],[ord08,ord08],'- -c'),...
  grid,title(t),xlabel(as),ylabel(o),...
  text(v(1)+(v(2)-v(1))/90,ord+(v(4)-v(3))/40,ords)
  text(v(1)+(v(2)-v(1))/90,ord08-(v(4)-v(3))/40,ord08s)
  text(i2n,0.05,[' ',num2str(i2n)])
  text(i2n/2,0.5,['  V1 = ',num2str(v1n),'  [V]'])
  text(i2n/2,0.45,['  f = ',num2str(fn),' [Hz]'])
input('Premi il tasto Return ...','s');

